unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, xmldom, XMLIntf, StdCtrls, ExtCtrls, msxmldom, XMLDoc, Spin,
  ComCtrls, IdUri;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    XMLDocument1: TXMLDocument;
    Button1: TButton;
    Panel1: TPanel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    ComboBox3: TComboBox;
    Label5: TLabel;
    DateTimePicker1: TDateTimePicker;
    Label6: TLabel;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    Label7: TLabel;
    Label8: TLabel;
    Button2: TButton;
    TreeView1: TTreeView;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    procedure ZpracujSpojeni(ispoj:IXMLDocument);
  public
    { Public declarations }
    seznamst:TStringList;
  end;

var
  Form1: TForm1;

implementation

uses SeznamStanicDef, DateUtils, NajdiSpojeniDef, StrUtils;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var iseznamstanic:IXMLSeznamStanicType;
    i:Integer;
begin
  XMLDocument1.FileName:='http://'+Edit1.Text+':'+SpinEdit1.Text+'/SeznamStanic';
  XMLDocument1.Active:=true;
  iseznamstanic:=GetSeznamStanic(XMLDocument1 as IXMLDocument);
  seznamst.Clear;
  for i:=0 to iseznamstanic.Count-1 do
   seznamst.Add(iseznamstanic.Nodes[i].NodeValue);
  seznamst.Sort; 
  ComboBox1.Items.Assign(seznamst);
  ComboBox2.Items.Assign(seznamst);
  ComboBox3.Items.Assign(seznamst);
  ComboBox3.Items.Insert(0,'');
  if ComboBox1.Items.Count>0 then
   ComboBox1.ItemIndex:=0;
  if ComboBox2.Items.Count>0 then
   ComboBox2.ItemIndex:=0;
  if ComboBox3.Items.Count>0 then
   ComboBox3.ItemIndex:=0;
  Panel1.Visible:=true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  seznamst:=TStringList.Create;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  seznamst.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
var q,h,m:String;
    ispoj:IXMLSpojeniType;
begin
  if ComboBox1.Text<>'' then
   if ComboBox2.Text<>'' then
   begin
     q:='?odkud='+ComboBox1.Text+'&kam='+ComboBox2.Text;
      if ComboBox3.Text<>'' then
       q:=q+'&pres='+ComboBox3.Text;
     h:=IntToStr(HourOf(DateTimePicker1.Time));
     if length(h)<2 then h:='0'+h;
     m:=IntToStr(MinuteOf(DateTimePicker1.Time));
     if length(m)<2 then m:='0'+m;
     q:=q+'&odjezd='+h+m;
     q:=q+'&prestupy='+SpinEdit2.Text;
     q:=q+'&spojeni='+SpinEdit3.Text;
     q:=AnsiReplaceText(q,' ','+');
     q:='http://'+Edit1.Text+':'+SpinEdit1.Text+'/NajdiSpojeni'+q;
     XMLDocument1.Active:=false;
     XMLDocument1.FileName:=q;
     XMLDocument1.Active:=true;
     TreeView1.Items.Clear;
     Memo1.Lines.Assign(XMLDocument1.XML);
     ZpracujSpojeni(XMLDocument1 as IXMLDocument);
     TreeView1.Visible:=true;

   end else
   begin
     ShowMessage('Zadejte odkud kam chcete jet.');
   end;
end;

procedure TForm1.ZpracujSpojeni(ispoj: IXMLDocument);

function timediff(odt,dot:String):String;
var t1,t2:TTime;
begin
  t1:=StrToTime(odt);
  t2:=StrToTime(dot);
  Result:=IntToStr(MinutesBetween(t1,t2));
end;

var
    i,j,k:Integer;
    root,tspoj,tpoz,tlinka:TTreeNode;
    spoj,linka,stanice,pozn:IXMLNode;
    prj,odj,sname:String;
    lst,let:String; //linka start time, linka end time
    sstim,setim:String; //spoj start time, spoj end time
    last:Boolean;
begin
  root:=TreeView1.Items.AddChild(nil,'Pocet spojeni: '+IntToStr(ispoj.DocumentElement.ChildNodes.Count));
  for i:=0 to ispoj.DocumentElement.ChildNodes.Count-1 do
  begin
    spoj:=ispoj.DocumentElement.ChildNodes[i];
    tspoj:=TreeView1.Items.AddChild(nil,'spoj');
    for j:=0 to spoj.ChildNodes.Count-1 do
    begin
      linka:=spoj.ChildNodes[j];
      tlinka:=TreeView1.Items.AddChild(tspoj,'Linka '+linka.Attributes['cislo']);
      tpoz:=TreeView1.Items.AddChild(tlinka,'Poznamky');
      for k:=0 to linka.ChildNodes.Count-1 do
      begin
        stanice:=linka.ChildNodes[k];
        pozn:=stanice;
        if stanice.NodeName='Stanice' then
        begin
          if stanice.HasAttribute('prijezd') then
          begin
            prj:=stanice.Attributes['prijezd'];
            last:=k=linka.ChildNodes.Count-1;
            if not last then
             if linka.ChildNodes[k+1].NodeName<>'Stanice' then
              last:=True;
            if last then
            begin
              let:=prj;
              if j=spoj.ChildNodes.Count-1 then
               setim:=prj;
            end;
          end;
          if stanice.HasAttribute('odjezd') then
          begin
            odj:=stanice.Attributes['odjezd'];
            if k=0 then
            begin
              lst:=odj;
              if j=0 then sstim:=odj;
            end;
            odj:='->'+odj;
          end;
          sname:=stanice.Text;
          TreeView1.Items.AddChild(tlinka,sname+' '+prj+odj);
        end else
        begin
          TreeView1.Items.AddChild(tpoz,pozn.NodeValue);
        end;
      end;
      tlinka.Text:=tlinka.Text+' cas od '+lst+' do '+let+' celkem '+timediff(lst,let)+' minut';
    end;
    tspoj.Text:=tspoj.Text+' cas od '+sstim+' do '+setim+' celkem '+timediff(sstim,setim)+' minut';
  end;
end;

end.
