unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPServer,
  IdCustomHTTPServer, IdHTTPServer, Spin, xmldom, XMLIntf, msxmldom, XMLDoc,
  IniFiles, ComObj, DateUtils;

type
  THrana=record
    odkud,kam:Integer;
    prestupna:Boolean;
    linka:ShortString;
//    prijezd,odjezd:ShortString;
    min:Integer;
  end;
  TForm1 = class(TForm)
    IdHTTPServer1: TIdHTTPServer;
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    SpinEdit1: TSpinEdit;
    Label2: TLabel;
    Button2: TButton;
    Button3: TButton;
    XMLDocument1: TXMLDocument;
    XMLResponseDocument: TXMLDocument;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure IdHTTPServer1CommandGet(AThread: TIdPeerThread;
      ARequestInfo: TIdHTTPRequestInfo;
      AResponseInfo: TIdHTTPResponseInfo);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure ZpracujStanice;
    procedure Log(r:STring);
    procedure WorkOutSearch(pars:TStrings);
    procedure QuickniHrany; //setridi hrany Quicksortem
  public
    { Public declarations }
    hran:Integer;
    hrany:array of THrana;
    hranyvrcholu:array of Integer;
    stanice:TStringList;
    fn:String;
  end;

var
  Form1: TForm1;

implementation

uses data, SeznamStanicDef, StrUtils;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
   Edit1.Text:=OpenDialog1.FileName;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  try
  Button3.Enabled:=true;
  Button2.Enabled:=false;
  IdHTTPServer1.DefaultPort:=SpinEdit1.Value;
  Log('Activating server');
  IdHTTPServer1.Active:=true;
  XMLDocument1.FileName:=Edit1.Text;
  fn:=XMLDocument1.FileName;
  XMLDocument1.Active:=true;
  Log('Working out list of stations');
  ZpracujStanice;
  except
    on E:Exception do
    begin
      ShowMessage(E.Message);
      Button3.Enabled:=not true;
      Button2.Enabled:=not false;
    end;
  end;
  Log('Ready');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  XMLDocument1.Active:=false;
  IdHTTPServer1.Active:=false;
  Button3.Enabled:=not true;
  Button2.Enabled:=not false;
end;

procedure TForm1.IdHTTPServer1CommandGet(AThread: TIdPeerThread;
  ARequestInfo: TIdHTTPRequestInfo; AResponseInfo: TIdHTTPResponseInfo);

var iseznst:IXMLSeznamStanicType;
    j:Integer;
    pars:TStrings;
begin
  XMLResponseDocument.XML.Clear;
  XMLResponseDocument.Active:=true;
  XMLResponseDocument.Encoding:='UTF-8';
  if ARequestInfo.Document='/SeznamStanic' then
  begin
    Log('Response on SEZNAMSTANIC');
    XMLResponseDocument.AddChild('SeznamStanic');
    for j:=0 to stanice.Count-1 do
     XMLResponseDocument.DocumentElement.AddChild('Stanice').Text:=stanice[j];
  end;
  if ARequestInfo.Document='/NajdiSpojeni' then
  begin
    pars:=ARequestInfo.Params;
    WorkOutSearch(pars);
  end;
  AResponseInfo.ContentText:=XMLResponseDocument.XML.Text;
  XMLResponseDocument.Active:=false;
end;

procedure TForm1.ZpracujStanice;
var
    st:TStringList;
    i,j,startp,endp,lastedge:Integer; //iterator, pozice zobacku v r
    stname,r:String;
    f:TextFile;
    linka:String;
    lastst,lasttime,newst,newtime:STring;
    lind,nind:Integer; //indexes
    hash:THashedStringList;
    a,b:TTime;
    d:Integer;
begin
  stanice.Clear;
  st:=TStringList.Create;
  AssignFile(f,fn);
  Reset(f);
  hran:=0;
  while not eof(f) do
  begin
    readln(f,r);
    startp:=Pos('<Stanice',r);
    if startp>0 then
    begin
      startp:=Pos('>',r)+1;
      endp:=PosEx('<',r,startp)-1;
      stname:=Copy(r,startp,endp-startp+1);
      st.Add(stname);
      inc(hran);
    end;
    if Pos('</Linka',r)>0 then
     dec(hran); //pocet hran je pocet vrcholu -1 na linku
  end;
  hran:=hran-1; //odpocteni prebyvajici hrany...
  st.Sort;
  stname:='';
  //setridit a nahazet do pole aby se neopakovaly
  for i:=0 to st.Count-1 do
  begin
    if st[i]<>stname then
    begin
      stname:=st[i];
      stanice.Add(stname);
    end;
  end;
  st.Free;
  CloseFile(f)
{  hash:=THashedStringList.Create;
  for i:=0 to stanice.Count-1 do
   hash.Add(stanice[i]);
  Log('Working out list of edges');
  //list of edges
  hrany:=nil;
  SetLength(hrany,hran);
  lastedge:=0;
  Reset(f);
  r:='';
  while (not eof(f)) or (Pos('</Linky',r)>0) do
  begin
    readln(f,r);
    startp:=Pos('<Linka',r);
    if startp>0 then
    begin
      startp:=Pos('cislo="',r)+length('cislo="');
      endp:=PosEx('"',r,startp)-1;
      linka:=Copy(r,startp,endp-startp+1);
      readln(f,r); //dalsi radka je stanice,  doufam :)
      startp:=Pos('odjezd="',r)+length('odjezd="');
      endp:=PosEx('"',r,startp)-1;
      lasttime:=Copy(r,startp,endp-startp+1);
      startp:=Pos('>',r)+1;
      endp:=PosEx('<',r,startp)-1;
      lastst:=Copy(r,startp,endp-startp+1);
      readln(f,r);
      lind:=hash.IndexOf(lastst);
      while (Pos('</Linka',r)=0) and (Pos('<Poznamka',r)=0) do
      begin
        if Pos('odjezd="',r)>0 then
         startp:=Pos('odjezd="',r)+length('odjezd="') else
         startp:=Pos('prijezd="',r)+length('prijezd="');
        endp:=PosEx('"',r,startp)-1;
        newtime:=Copy(r,startp,endp-startp+1);
        startp:=Pos('>',r)+1;
        endp:=PosEx('<',r,startp)-1;
        newst:=Copy(r,startp,endp-startp+1);
        if lastedge>hran then ShowMessage('SHIT');
//        hrany[lastedge].odkud:={lind0;
//        nind:=hash.IndexOf(newst);
//        hrany[lastedge].kam:=nind;
//        hrany[lastedge].prestupna:=false;
//        hrany[lastedge].linka:=linka;
//        hrany[lastedge].prijezd:=lasttime;
//        hrany[lastedge].odjezd:=newtime;
 {       if newtime<>'24:00' then
        begin
//          hrany[lastedge].min:=MinutesBetween(StrToTime(lasttime),StrToTime(newtime));
        end else
        begin
          a:=StrToTime(lasttime);
          b:=StrToTime('0:00');
          d:=24*60-MinutesBetween(a,b);
//          hrany[lastedge].min:=d;
        end;
        lasttime:=newtime;
        lastst:=newst;
        lind:=nind;
        inc(lastedge);
        readln(f,r);
      end;
    end;
  end;
  hash.Clear;
  hash.Free;
  Log('Optimalizing data');
  SetLength(hranyvrcholu,hran);
{  for i:=0 to hran-1 do
   Memo1.Lines.Add(IntToStr(hrany[i].odkud)+'->'+IntToStr(hrany[i].kam));}
{  for i:=0 to hran do
   hranyvrcholu[i]:=i;
  QuickniHrany;
  lastedge:=0;
  for i:=0 to stanice.Count-1 do
  begin
    stanice.Objects[i]:=TObject(lastedge);
    j:=lastedge+1;
    while hrany[hranyvrcholu[j]].odkud=hrany[hranyvrcholu[lastedge]].odkud do inc(j);
    lastedge:=j;
    Log(IntToStr(j));
  end;
  CloseFile(f);}
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  stanice:=TStringList.Create;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if IdHTTPServer1.Active then
   Button3.Click;
  stanice.Free; 
end;

procedure TForm1.Log(r: STring);
begin
  Memo1.Lines.Add(r);
end;


procedure TForm1.WorkOutSearch(pars: TStrings);
function Fill(what:String; len:Integer=2):String;
begin
  Result:=what;
  while length(result)<len do
   Result:='0'+Result;
end;

var odkud,kam,pres,odjezd,prestupy,spojeni:String;
    chyba:Boolean;
begin
  if pars.IndexOfName('odkud')<>0 then
   odkud:=pars.Values['odkud'] else chyba:=true;
  if pars.IndexOfName('kam')<>0 then
   kam:=pars.Values['kam'] else chyba:=true;
  if pars.IndexOfName('pres')<>0 then
   pres:=pars.Values['pres'] else pres:='';
  if pars.IndexOfName('odjezd')<>0 then
   odjezd:=pars.Values['odjezd'] else
   begin
     odjezd:=Fill(IntToStr(HourOf(Time)))+Fill(IntToStr(MinuteOf(Time)));
   end;
  if pars.IndexOfName('prestupy')<>0 then
   prestupy:=pars.Values['prestupy'] else prestupy:='0';
  if pars.IndexOfName('spojeni')<>0 then
   spojeni:=pars.Values['spojeni'] else spojeni:='5';

  if Chyba then
  begin
    XMLResponseDocument.AddChild('Chyba').Text:='Nezadali jste odkud kam';
  end else
    XMLResponseDocument.AddChild('Chyba').Text:='Tato funkce neni dostupna';
end;

procedure TForm1.QuickniHrany;

  procedure QuickSort(var A: array of Integer; iLo, iHi: Integer);
  var
    Lo, Hi, Mid, T: Integer;
    Median:THrana;
    function Mensi(x:Integer):Boolean;
    begin
///      try
        Result:=hrany[x].odkud<Median.odkud;
//       except
//         Log(IntToSTr(x)+' '+IntToSTr(Median.odkud));
//       end;
    end;

  begin
    Lo := iLo;
    Hi := iHi;
    Mid := A[(Lo + Hi) div 2];
    Median:=hrany[mid];
    repeat
      while Mensi(A[Lo]) do Inc(Lo);
      while not Mensi(A[Hi]) do Dec(Hi);
      if Lo <= Hi then
      begin
        T := A[Lo];
        A[Lo] := A[Hi];
        A[Hi] := T;
        Inc(Lo);
        Dec(Hi);
      end;
    until Lo > Hi;
    if Hi > iLo then QuickSort(A, iLo, Hi);
    if Lo < iHi then QuickSort(A, Lo, iHi);
  end;

begin
  QuickSort(hranyvrcholu, Low(hranyvrcholu), High(hranyvrcholu));
end;

initialization
finalization
end.
